diff --git a/src/ck-seat.c b/src/ck-seat.c
index af7db59..dd2a387 100644
--- a/src/ck-seat.c
+++ b/src/ck-seat.c
@@ -1025,6 +1662,13 @@ ck_seat_class_init (CkSeatClass *klass)
                                                             CK_SEAT_KIND_DYNAMIC,
                                                             G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
 
+        g_object_class_install_property (object_class,
+                                         PROP_TYPE,
+                                         g_param_spec_string ("type",
+                                                              "type",
+                                                              "type",
+                                                              NULL,
+                                                              G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
         g_type_class_add_private (klass, sizeof (CkSeatPrivate));
 
         dbus_g_object_type_install_info (CK_TYPE_SEAT, &dbus_glib_ck_seat_object_info);
@@ -1040,6 +1684,7 @@ ck_seat_init (CkSeat *seat)
                                                       g_free,
                                                       (GDestroyNotify) g_object_unref);
         seat->priv->devices = g_ptr_array_new ();
+        seat->priv->manager_proxy = NULL;
 }
 
 static void
@@ -1065,28 +1710,32 @@ ck_seat_finalize (GObject *object)
         g_ptr_array_free (seat->priv->devices, TRUE);
         g_hash_table_destroy (seat->priv->sessions);
         g_free (seat->priv->id);
+        g_free (seat->priv->type);
 
         G_OBJECT_CLASS (ck_seat_parent_class)->finalize (object);
 }
 
 CkSeat *
 ck_seat_new (const char *sid,
-             CkSeatKind  kind)
+             CkSeatKind  kind,
+             const char *type)
 {
         GObject *object;
 
         object = g_object_new (CK_TYPE_SEAT,
                                "id", sid,
                                "kind", kind,
+                               "type", type,
                                NULL);
 
         return CK_SEAT (object);
 }
 
 CkSeat *
-ck_seat_new_with_devices (const char *sid,
-                          CkSeatKind  kind,
-                          GPtrArray  *devices)
+ck_seat_new_with_devices_and_sessions (const char *sid,
+                                       CkSeatKind  kind,
+                                       GPtrArray  *devices,
+                                       GPtrArray  *sessions)
 {
         GObject *object;
         int      i;
@@ -1101,27 +1750,62 @@ ck_seat_new_with_devices (const char *si
                         ck_seat_add_device (CK_SEAT (object), g_ptr_array_index (devices, i), NULL);
                 }
         }
+        if (sessions != NULL) {
+                for (i = 0; i < sessions->len; i++) {
+                        ck_seat_add_session (CK_SEAT (object), g_ptr_array_index (sessions, i), NULL);
+                }
+        }
+
 
         return CK_SEAT (object);
 }
 
+static char *
+generate_static_session_id (const char *sid,
+                            const char *session_name)
+{
+        const char *seat_name;
+        char *ssid;
+
+        seat_name = strrchr (sid, '/');
+
+        if (seat_name == NULL) {
+                g_warning ("Seat id '%s' lacks a /", sid);
+                seat_name = sid;
+        } else {
+                seat_name++;
+        }
+
+        ssid = g_strdup_printf ("%s/Session%s%s",
+                                CK_DBUS_PATH, seat_name,
+                                session_name);
+
+        return ssid;
+}
+
 CkSeat *
-ck_seat_new_from_file (const char *sid,
+ck_seat_new_from_file (char       **sid,
                        const char *path)
 {
-        GKeyFile  *key_file;
-        gboolean   res;
-        GError    *error;
-        char      *group;
-        CkSeat    *seat;
-        gboolean   hidden;
-        GPtrArray *devices;
-        char     **device_list;
-        gsize      ndevices;
-        gsize      i;
+        GKeyFile      *key_file;
+        gboolean       res;
+        GError        *error;
+        char          *group;
+        CkSeat        *seat;
+        char          *read_sid;
+        gboolean       hidden;
+        GPtrArray     *sessions;
+        char         **session_list;
+        gsize          nsessions;
+        GPtrArray     *devices;
+        char         **device_list;
+        gsize          ndevices;
+        gsize          i;
 
         seat = NULL;
 
+        g_debug ("CkSeat: New seat from file.");
+
         key_file = g_key_file_new ();
         error = NULL;
         res = g_key_file_load_from_file (key_file,
@@ -1146,9 +1830,52 @@ ck_seat_new_from_file (const char *sid,
                 goto out;
         }
 
+        read_sid = g_key_file_get_string (key_file, group, "ID", NULL);
+        if (IS_STR_SET (read_sid)) {
+                g_free (*sid);
+                *sid = g_strdup_printf ("%s/%s", CK_DBUS_PATH, read_sid);
+        } else {
+                g_free (read_sid);
+        }
+
+        session_list = g_key_file_get_string_list (key_file, group, "Sessions", &nsessions, NULL);
+
+        sessions = g_ptr_array_sized_new (nsessions);
+
+        for (i = 0; i < nsessions; i++) {
+                char *path;
+                char *file;
+                char *ssid;
+                CkSession *session;
+
+                file = g_strconcat (session_list[i], ".session", NULL);
+                path = g_build_filename (CK_SESSION_DIR, file, NULL);
+                g_free (file);
+
+                /* FIXME: we should probably use the same naming pool as
+                 * sessions generated from ck-manager.  We mangle the name
+                 * here so we don't clash with names from ck-manager
+                 */
+                ssid = generate_static_session_id (*sid, session_list[i]);
+
+                session = ck_session_new_from_file (ssid, path);
+
+                if (session == NULL) {
+                        g_warning ("Unable to load session from file %s", path);
+                        g_free (path);
+                        continue;
+                }
+                g_free (path);
+                ck_session_set_seat_id (session, *sid, NULL);
+
+                g_ptr_array_add (sessions, session);
+        }
+
+        g_strfreev (session_list);
+
         device_list = g_key_file_get_string_list (key_file, group, "Devices", &ndevices, NULL);
 
-        g_debug ("Creating seat %s with %zd devices", sid, ndevices);
+        g_debug ("CkSeat: Creating seat %s with %zd devices", *sid, ndevices);
 
         devices = g_ptr_array_sized_new (ndevices);
 
@@ -1177,11 +1904,12 @@ ck_seat_new_from_file (const char *sid,
                 g_strfreev (split);
         }
         g_strfreev (device_list);
-        g_free (group);
 
-        seat = ck_seat_new_with_devices (sid, CK_SEAT_KIND_STATIC, devices);
+        seat = ck_seat_new_with_devices_and_sessions (*sid, CK_SEAT_KIND_STATIC, devices, sessions);
         g_ptr_array_free (devices, TRUE);
 
+        g_free (group);
+
 out:
 
         g_key_file_free (key_file);
@@ -1356,10 +2084,15 @@ ck_seat_dump (CkSeat   *seat,
 
                 error = NULL;
                 if (! ck_session_get_id (seat->priv->active_session, &session_id, &error)) {
-                        g_warning ("Cannot get session id for active session on seat %s: %s",
-                                   seat->priv->id,
-                                   error->message);
-                        g_error_free (error);
+                        if (error) {
+                                g_warning ("Cannot get session id for active session on seat %s: %s",
+                                           seat->priv->id,
+                                           error->message);
+                                g_error_free (error);
+                        } else {
+                                g_warning ("Cannot get session id for active session on seat %s",
+                                           seat->priv->id);
+                        }
                 } else {
                         g_key_file_set_string (key_file,
                                                group_name,
@@ -1371,3 +2104,24 @@ ck_seat_dump (CkSeat   *seat,
 
         g_free (group_name);
 }
+
+gboolean
+ck_seat_is_managed (CkSeat *seat)
+{
+        return seat->priv->manager_proxy != NULL;
+}
+
+CkSession *
+ck_seat_get_session (CkSeat                *seat,
+                     const char            *ssid)
+{
+        CkSession *session;
+
+        session = g_hash_table_lookup (seat->priv->sessions, ssid);
+
+        if (session == NULL) {
+                return NULL;
+        }
+
+        return g_object_ref (session);
+}
diff --git a/src/ck-seat.h b/src/ck-seat.h
index fb9a955..6276021 100644
--- a/src/ck-seat.h
+++ b/src/ck-seat.h
@@ -47,6 +47,18 @@ typedef struct
 {
         GObjectClass   parent_class;
 
+        void          (* remove_request)         (CkSeat      *seat);
+        void          (* open_session_request)   (CkSeat      *seat,
+                                                  const char  *ssid,
+                                                  const char  *session_type,
+                                                  const char  *display_template_name,
+                                                  GHashTable  *display_variables,
+                                                  const char  *display_type,
+                                                  GHashTable  *parameters);
+        void          (* close_session_request)  (CkSeat      *seat,
+                                                  const char  *ssid);
+        void          (* no_respawn)             (CkSeat      *seat,
+                                                  const char  *ssid);
         void          (* active_session_changed) (CkSeat      *seat,
                                                   const char  *ssid);
         void          (* session_added)          (CkSeat      *seat,
@@ -57,6 +69,11 @@ typedef struct
                                                   GValueArray *device);
         void          (* device_removed)         (CkSeat      *seat,
                                                   GValueArray *device);
+        void          (* session_to_add)         (CkSeat      *seat,
+                                                  gboolean     is_dynamic,
+                                                  const char  *command);
+        void          (* session_to_remove)      (CkSeat      *seat,
+                                                  int          display_number);
 } CkSeatClass;
 
 typedef enum
@@ -84,12 +101,14 @@ typedef enum
 GQuark              ck_seat_error_quark         (void);
 GType               ck_seat_get_type            (void);
 CkSeat            * ck_seat_new                 (const char            *sid,
-                                                 CkSeatKind             kind);
-CkSeat            * ck_seat_new_from_file       (const char            *sid,
-                                                 const char            *path);
-CkSeat            * ck_seat_new_with_devices    (const char            *sid,
                                                  CkSeatKind             kind,
-                                                 GPtrArray             *devices);
+                                                 const char            *type);
+CkSeat            * ck_seat_new_from_file       (char                 **sid,
+                                                 const char            *path);
+CkSeat            * ck_seat_new_with_devices_and_sessions    (const char            *sid,
+                                                              CkSeatKind             kind,
+                                                              GPtrArray             *devices,
+                                                              GPtrArray             *sessions);
 
 gboolean            ck_seat_register            (CkSeat                *seat);
 
@@ -104,18 +123,31 @@ void                ck_seat_dump        
 gboolean            ck_seat_get_kind            (CkSeat                *seat,
                                                  CkSeatKind            *kind,
                                                  GError               **error);
+gboolean            ck_seat_get_type_string     (CkSeat                *seat,
+                                                 char                 **type,
+                                                 GError               **error);
 gboolean            ck_seat_add_session         (CkSeat                *seat,
                                                  CkSession             *session,
                                                  GError               **error);
 gboolean            ck_seat_remove_session      (CkSeat                *seat,
                                                  CkSession             *session,
                                                  GError               **error);
+gboolean            ck_seat_request_open_session (CkSeat                *seat,
+                                                  CkSession             *session,
+                                                  GError               **error);
+gboolean            ck_seat_request_close_session (CkSeat                *seat,
+                                                   CkSession             *session,
+                                                   GError               **error);
 gboolean            ck_seat_add_device          (CkSeat                *seat,
                                                  GValueArray           *device,
                                                  GError               **error);
 gboolean            ck_seat_remove_device       (CkSeat                *seat,
                                                  GValueArray           *device,
                                                  GError               **error);
+gboolean            ck_seat_is_managed          (CkSeat                *seat);
+CkSession          *ck_seat_get_session         (CkSeat                *seat,
+                                                 const char            *ssid);
+void                ck_seat_request_removal     (CkSeat                *seat);
 
 /* exported methods */
 gboolean            ck_seat_get_id                (CkSeat                *seat,
@@ -137,6 +169,14 @@ gboolean            ck_seat_can_activate
 gboolean            ck_seat_activate_session      (CkSeat                *seat,
                                                    const char            *ssid,
                                                    DBusGMethodInvocation *context);
+gboolean            ck_seat_manage                (CkSeat                *seat,
+                                                   DBusGMethodInvocation *context);
+gboolean            ck_seat_unmanage              (CkSeat                *seat,
+                                                   DBusGMethodInvocation *context);
+
+gboolean            ck_seat_no_respawn            (CkSeat                *seat,
+                                                   CkSession             *session,
+                                                   GError               **error);
 
 G_END_DECLS
 
diff --git a/src/ck-session-leader.c b/src/ck-session-leader.c
index 3702602..908d2bb 100644
--- a/src/ck-session-leader.c
+++ b/src/ck-session-leader.c
@@ -238,6 +238,7 @@ static struct {
         { "x11-display",        add_param_string },
         { "remote-host-name",   add_param_string },
         { "session-type",       add_param_string },
+        { "display-type",       add_param_string },
         { "is-local",           add_param_boolean },
         { "unix-user",          add_param_int },
 };
